Unit SFG6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF66R_p, UTSF12_p, SFG6R1_p;

function SFG6R(X :Real; A :Real; B :Real; EPS :Real;
                ITMAX :Integer; var IERR :Integer): Real;

implementation

function SFG6R(X :Real; A :Real; B :Real; EPS :Real;
                ITMAX :Integer; var IERR :Integer): Real;
var
SFG6R,BT,R1,R2,R3 :Real;
const
SYS053 :Real = 3.4E38;
label
_10,_70,_20,_30,_40,_50,_60;
begin
{ Result -    SFG6R  FORTRANe }
IERR := 0;
if ( X >= 0.0 ) or ( X <= 1.0 ) 
 then goto _10;
IERR := 65;
goto _50;
_10:
if ( A > 0.0 ) and ( B > 0.0 ) 
 then goto _70;
IERR := 66;
goto _50;
_70:
if ( X <> 0.0 ) or ( X <> 1.0 ) 
 then goto _20;
BT := 0.0;
goto _30;
_20:
SF66R(A+B,R1,IERR);
SF66R(A,R2,IERR);
SF66R(B,R3,IERR);
BT := Exp(R1-R2-R3+A*Ln(X)+B*Ln(1.0-X));
_30:
if ( X >= (A+1.0)/(A+B+1.0) ) 
 then goto _40;
Result := BT*SFG6R1(X,A,B,EPS,ITMAX,IERR)/A;
if ( IERR <> 0 ) 
 then goto _50;
goto _60;
_40:
Result := 1.0-BT*SFG6R1(1.0-X,B,A,EPS,ITMAX,IERR)/B;
if ( IERR = 0 ) 
 then goto _60;
_50:
Result := SYS053;
UTSF12(IERR,52);
_60:
exit;
end;

end.
